---
name: Report a bug
about: Create a report to help us improve
labels: bug

---

<!--

This form is for bug reports and feature requests ONLY!
For general questions and troubleshooting, please ask/look for answers here:
- Documentation: https://docs.microsoft.com/aspnet/core/grpc
- Troubleshooting: https://docs.microsoft.com/aspnet/core/grpc/troubleshoot
- StackOverflow, with "grpc" tag: https://stackoverflow.com/questions/tagged/grpc

Issues specific to Grpc.Core (C-core server and client), or code generation with Grpc.Tools should be created at https://github.com/grpc/grpc/issues/new
-->

### What version of gRPC and what language are you using?


### What operating system (Linux, Windows,...) and version?


### What runtime / compiler are you using (e.g. .NET Core SDK version `dotnet --info`)


### What did you do?
If possible, provide a recipe for reproducing the error. Try being specific and include code snippets if helpful.

### What did you expect to see?


### What did you see instead?

Make sure you include information that can help us debug (full error message, exception listing, stack trace, logs).

See [TROUBLESHOOTING.md](https://github.com/grpc/grpc-dotnet/blob/master/TROUBLESHOOTING.md) for how to diagnose problems better.

### Anything else we should know about your project / environment?
