#region Copyright notice and license

// Copyright 2015 gRPC authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#endregion

using System;
using NUnit.Framework;

namespace Grpc.Core.Tests;

public class ChannelCredentialsTest
{
    [Test]
    public void ChannelCredentials_CreateComposite()
    {
        var composite = ChannelCredentials.Create(new FakeChannelCredentials(true), new FakeCallCredentials());
        Assert.IsFalse(composite.IsComposable);

        Assert.AreEqual("channelCredentials", Assert.Throws<ArgumentNullException>(() => ChannelCredentials.Create(null!, new FakeCallCredentials()))!.ParamName);
        Assert.AreEqual("callCredentials", Assert.Throws<ArgumentNullException>(() => ChannelCredentials.Create(new FakeChannelCredentials(true), null!))!.ParamName);
    }
}
